#ifndef ANNOTATION_H
#define ANNOTATION_H

#include <QString>
#include <QColor>
#include <QRect>


class Annotation
{
public:
    Annotation(int, float, QString, QString, QString, QColor);
    const QString& getAnnotation();
    const QString& getParagraph();
    const QString& getText();
    int getSection();
    int getPage();
    int getScroll();
    float getPercentage();
    const QColor& getColor();

private:
    QColor color;
    int section;
    int page;
    int scroll;
    float percentage;
    QString annotation;
    QString paragraph;
    QString text;
    int number;

};

#endif
