#include "page.h"
#include <QDebug>
#include <QGraphicsScene>

Page::Page(QGraphicsItem *parent, Qt::WindowFlags wFlags) : QGraphicsWidget(parent, wFlags)
{
    layout = new QGraphicsLinearLayout(Qt::Vertical, this);
    content = new PixmapWidget();
    layout->addItem(content);
    

/*    header = new QLabel();
    header->setStyleSheet("QLabel{background: " + QColor(Qt::lightGray).name() +";color: #000000;}");
    QFont font = header->font();
    font.setPixelSize(30);
    header->setFont(font);*/
}

void Page::setPixmap(QPixmap p)
{
    content->setPixmap(p);
    update();
}

void Page::addPixmap(QPixmap p)
{
    content->addPixmap(p);
}

void Page::clearPixmap()
{
    content->clearPixmap();
    update();
}

void Page::setContentHeight(int height)
{
    QRectF g = content->geometry();
    content->setGeometry(g.x(), g.y(), g.width(), height);
}

QRectF Page::boundingRect() const
{
    return geometry();
}

/*void Page::setHeaderText(const QString text)
{
    headerText = text;
    header->setText(text);

    if(scene()->children().count() < 2){
        QGraphicsProxyWidget *w = scene()->addWidget(header);
        layout->insertItem(0, (QGraphicsWidget*)w);
        layout->setAlignment((QGraphicsWidget*)w, Qt::AlignCenter);
        content->adjustSize();
        adjustSize();
    }

}*/


void Page::mousePressEvent(QGraphicsSceneMouseEvent *event)
{
    handleMouseEvent(event);
}
void Page::mouseReleaseEvent(QGraphicsSceneMouseEvent *event)
{
    handleMouseEvent(event);
}
void Page::mouseMoveEvent(QGraphicsSceneMouseEvent *event)
{
    handleMouseEvent(event);
}
void Page::mouseDoubleClickEvent(QGraphicsSceneMouseEvent *event)
{
    handleMouseEvent(event);
}

QSize Page::viewportSize() const
{
    return size().toSize();
}
QPoint Page::maximumScrollPosition() const
{
    QSizeF s = content->size() - size();
    return QPoint(qMax(0, int(s.width())), qMax(0, int(s.height())));
}
QPoint Page::scrollPosition() const
{
    return -content->pos().toPoint() + overShoot;
}
void Page::setScrollPosition(const QPoint &p, const QPoint &os)
{
    overShoot = os;
    content->setPos(-p + overShoot);
}
